# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2021"
name = "bf-tree"
version = "0.5.3"
build = false
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "Bf-Tree is a modern read-write-optimized concurrent larger-than-memory range index in Rust from Microsoft Research."
readme = "README.md"
license = "MIT"

[features]
metrics = [
    "dep:auto_ops",
    "dep:hdrhistogram",
    "dep:chrono",
    "dep:variant_count",
]
metrics-rt = [
    "dep:auto_ops",
    "dep:hdrhistogram",
    "dep:chrono",
    "dep:variant_count",
]
metrics-rt-debug-all = [
    "dep:auto_ops",
    "dep:hdrhistogram",
    "dep:chrono",
    "dep:variant_count",
]
metrics-rt-debug-timer = [
    "dep:auto_ops",
    "dep:hdrhistogram",
    "dep:chrono",
    "dep:variant_count",
]
shuttle = []
tracing = ["dep:tracing"]

[lib]
name = "bf_tree"
path = "src/lib.rs"

[dependencies.auto_ops]
version = "0.3"
optional = true

[dependencies.cfg-if]
version = "=1.0.0"

[dependencies.chrono]
version = "0.4.38"
optional = true

[dependencies.hdrhistogram]
version = "7.5.4"
optional = true

[dependencies.rand]
version = "0.9.4"
features = ["small_rng"]

[dependencies.serde]
version = "1"
features = ["derive"]

[dependencies.serde_json]
version = "1.0.116"

[dependencies.thread_local]
version = "1.1.9"

[dependencies.toml]
version = "0.8.23"

[dependencies.tracing]
version = "0.1"
optional = true

[dependencies.variant_count]
version = "1.1.0"
optional = true

[dev-dependencies.bytemuck]
version = "1.24.0"
features = ["must_cast"]

[dev-dependencies.proptest]
version = "1.6.0"

[dev-dependencies.proptest-derive]
version = "0.5.1"

[dev-dependencies.rstest]
version = "0.19.0"

[dev-dependencies.shuttle]
version = "0.7.1"

[dev-dependencies.tempfile]
version = "3.10.1"

[dev-dependencies.tracing-subscriber]
version = "0.3"

[target.'cfg(target_os = "linux")'.dependencies.io-uring]
version = "0.6.4"

[target.'cfg(target_os = "linux")'.dependencies.libc]
version = "0.2.155"

[target.'cfg(target_os = "windows")'.dependencies.windows-sys]
version = "0.59.0"
features = [
    "Win32_System_Threading",
    "Win32_System_WindowsProgramming",
]

[profile.release]
debug = 2
